src/main/java/br/com/home/gestor/controller/MovimentacoesController.java
package br.com.home.gestor.controller;

import br.com.home.gestor.dh.ItemFiltroCategoria;
import br.com.home.gestor.dh.ItemFiltroModoPagamento;
import br.com.home.gestor.modelo.Categoria;
import br.com.home.gestor.modelo.Lancamento;
import br.com.home.gestor.modelo.Mes;
import br.com.home.gestor.modelo.TipoPagamento;
import br.com.home.gestor.service.CategoriaService;
import br.com.home.gestor.service.LancamentoService;
import br.com.home.gestor.service.TipoPagamentoService;
import br.com.home.gestor.util.DateUtil;
import br.com.home.gestor.util.faces.JsfUtil;
import com.google.common.base.Function;
import com.google.common.base.Predicate;
import com.google.common.collect.FluentIterable;
import com.google.common.collect.Iterables;
import com.google.common.collect.Lists;
import org.apache.commons.collections.CollectionUtils;
import org.joda.time.LocalDate;
import org.springframework.context.annotation.Scope;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;

import static br.com.home.gestor.util.Constantes.BR;

@Named
@Scope("view")
public class MovimentacoesController implements Serializable{

	@Inject
	private LancamentoService lancamentoService;
	
	@Inject
	private TipoPagamentoService tipoPagamentoService;
	
	private Date data;
	
	private List<Lancamento> lancamentos;
	
	private BigDecimal totalReceitas;
	
	private BigDecimal totalDespezas;
	
	private BigDecimal saldoAnterior;
	
	private BigDecimal totalReceitaParcial = BigDecimal.ZERO;
	
	private BigDecimal totalDespezaParcial = BigDecimal.ZERO;
	
	private boolean mostraConfirmarExclusao;
	
	private ItemFiltroCategoria itemFiltroCategoria;
	
	private ItemFiltroModoPagamento itemFiltroModoPagamento;
	
	private List<ItemFiltroCategoria> categorias = Lists.newArrayList();
	
	private List<ItemFiltroModoPagamento> modosPagamento = Lists.newArrayList();
	
	@Inject
	private CategoriaService categoriaService;
	
	private List<Categoria> categoriasSelecionadas = Lists.newArrayList();
	
	private List<TipoPagamento> modosPagamentoSelecionados = Lists.newArrayList();
	
	
	private Mes mes;
	private int ano;
	
	
	private static final Predicate<ItemFiltroModoPagamento> MODOS_PAGAMENTO_SELECIONADOS_PREDICATE = new Predicate<ItemFiltroModoPagamento>() {

		@Override
		public boolean apply(ItemFiltroModoPagamento item) {
			return item.isSelecionado();
		}
	};
	
	private static final Function<ItemFiltroModoPagamento, TipoPagamento> MODOS_PAGAMENTO_SELECIONADOS_FUNCTION = new Function<ItemFiltroModoPagamento, TipoPagamento>() {

		@Override
		public TipoPagamento apply(ItemFiltroModoPagamento item) {
			return item.getTipoPagamento();
		}
	};
	
	
	private static final Predicate<ItemFiltroCategoria> CATEGORIAS_SELECIONADAS_PREDICATE = new Predicate<ItemFiltroCategoria>() {

		@Override
		public boolean apply(ItemFiltroCategoria item) {
			return item.isSelecionado();
		}
	};
	
	
	private static final Function<ItemFiltroCategoria, Categoria> CATEGORIAS_SELECIONADAS_FUNCTION = new Function<ItemFiltroCategoria, Categoria>() {

		@Override
		public Categoria apply(ItemFiltroCategoria item) {
			return item.getCategoria();
		}
	};
	
	@PostConstruct
	public void init(){
		
		LocalDate hoje = LocalDate.now();
		data = hoje.toDate();
		ano = hoje.getYear();
		List<Categoria> list = categoriaService.findAll();
		for (Categoria categoria : list) {
			ItemFiltroCategoria item = new ItemFiltroCategoria(categoria);
			categorias.add(item);
		}
		
		Collections.sort(categorias, new Comparator<ItemFiltroCategoria>() {

			@Override
			public int compare(ItemFiltroCategoria i1, ItemFiltroCategoria i2) {
				return i1.getCategoria().getNome().compareToIgnoreCase(i2.getCategoria().getNome());
			}
		});
		
		List<TipoPagamento> listaTiposPagamento = tipoPagamentoService.findAll();
		for (TipoPagamento tipoPagamento : listaTiposPagamento) {
			modosPagamento.add(new ItemFiltroModoPagamento(tipoPagamento));
		}
		Collections.sort(modosPagamento, new Comparator<ItemFiltroModoPagamento>() {

			@Override
			public int compare(ItemFiltroModoPagamento o1,
					ItemFiltroModoPagamento o2) {
				return o1.getText().compareToIgnoreCase(o2.getText());
			}
		});
		
		mes = new Mes(hoje.getMonthOfYear());
		
		buscar();
	}
	
	public void filtrar(){
		data = new LocalDate(ano, mes.getId(), 1).toDate();
		buscar();
	}
	
	public void resetaBusca(){
		data = LocalDate.now().toDate();
		buscar();
	}
	
	public void buscar(){
		lancamentos = lancamentoService.findLancamentosNoMes(data);
		calculaReceitasDespezas();
		zerarTotaisParciais();

		filtrarPorCategoriasSelecionadas();
		filtrarPorModosPagamentoSelecionados();
		
	}

	private void filtrarPorModosPagamentoSelecionados() {
		if(!CollectionUtils.isEmpty(modosPagamentoSelecionados)){
			final List<Lancamento> list = FluentIterable.from(lancamentos).filter(new LancamentosPorModoPagamentoPredicate(modosPagamentoSelecionados)).toList();
			lancamentos = new ArrayList<>(list);
			calculaTotaisParciais();
		}
	}

	private void filtrarPorCategoriasSelecionadas() {
		if(categoriasSelecionadas != null && !categoriasSelecionadas.isEmpty()){

			Predicate<Lancamento> lancamentosCategorizadosPredicate = new LancamentosPorCategoriaPredicate(categoriasSelecionadas);
			
			List<Lancamento> list = Lists.newArrayList(Iterables.filter(lancamentos, lancamentosCategorizadosPredicate));
			lancamentos = new ArrayList<>(list);
			calculaTotaisParciais();
		}
	}
	
	private void zerarTotaisParciais(){
		totalDespezaParcial = totalReceitaParcial = BigDecimal.ZERO;
	}
	
	private void calculaTotaisParciais() {
		
		for (Lancamento lancamento : lancamentos) {
			if(lancamento.isEntrada()){
				totalReceitaParcial = totalReceitaParcial.add(lancamento.getValor());
			}else{
				totalDespezaParcial = totalDespezaParcial.add(lancamento.getValor());
			}
		}
	}

	public void adicionarReceita(){
		JsfUtil.redirect(JsfUtil.prettyURL(Redirect.LANCAMENTO_ENTRADA));
	}
	
	public void addOuRemoveItemFiltroCategoria(){
		itemFiltroCategoria.setSelecionado(!itemFiltroCategoria.isSelecionado());
		categoriasSelecionadas = Lists.newArrayList(
				Iterables.transform(Lists.newArrayList(Iterables.filter(categorias, CATEGORIAS_SELECIONADAS_PREDICATE)),
				CATEGORIAS_SELECIONADAS_FUNCTION));
		
		buscar();
	}
	
	public void limparFiltroCategorias(){
		categoriasSelecionadas = Lists.newArrayList();
		for (ItemFiltroCategoria item : categorias) {
			item.setSelecionado(false);
		}
		buscar();
	}
	
	public void addOuRemoveItemFiltroModoPagamento(){
		itemFiltroModoPagamento.setSelecionado(!itemFiltroModoPagamento.isSelecionado());
		modosPagamentoSelecionados = FluentIterable.from(modosPagamento)
					.filter(MODOS_PAGAMENTO_SELECIONADOS_PREDICATE)
					.transform(MODOS_PAGAMENTO_SELECIONADOS_FUNCTION).toList();
		buscar();
	}
	
	public void limparFiltroModoPagamento(){
		modosPagamentoSelecionados = Lists.newArrayList();
		for (ItemFiltroModoPagamento item : modosPagamento) {
			item.setSelecionado(false);
		}
		buscar();
	}
	
	public void editar(Lancamento lancamento){
		
		JsfUtil.redirect(JsfUtil.prettyURL(Redirect.LANCAMENTO,"lancamentoId", lancamento.getId() ));
	}
	
	public void remover(Lancamento lancamento){
		lancamentos.remove(lancamento);
		lancamentoService.remove(lancamento.getId());
		zerarTotaisParciais();
		filtrarPorCategoriasSelecionadas();
		filtrarPorModosPagamentoSelecionados();
		JsfUtil.addInfoMessage("Lançamento removido com sucesso");
	}
	
	public void pago(Lancamento lancamento){
		lancamento.setPago(true);
		lancamentoService.save(lancamento);
	}
	
	public void naoPago(Lancamento lancamento){
		lancamento.setPago(false);
		lancamentoService.save(lancamento);
	}

	private void calculaReceitasDespezas() {
		
		LocalDate dataBase = LocalDate.fromDateFields(data);
		int mes = dataBase.getMonthOfYear();
		int ano = dataBase.getYear();
		totalReceitas = lancamentoService.calculaTotalEntradasMes(DateUtil.getDataInicial(mes, ano), 
				DateUtil.getDataFinal(mes, ano));
		totalDespezas = lancamentoService.calculaTotalSaidasMes(DateUtil.getDataInicial(mes, ano), 
				DateUtil.getDataFinal(mes, ano));

		saldoAnterior = lancamentoService.calculaSaldoMesAnterior(data);
		totalReceitaParcial = totalReceitas;
		totalDespezaParcial = totalDespezas;
	}

	public Date getData() {
		return DateUtil.getNewDate(data);
	}

	public void setData(Date data) {
		this.data = data;
	}

	public List<Lancamento> getLancamentos() {
		return lancamentos;
	}
	
	public void voltaMes(){
		data = LocalDate.fromDateFields(data).minusMonths(1).toDateTimeAtStartOfDay().toDate();
		buscar();
	}
	
	public void avancaMes(){
		data = LocalDate.fromDateFields(data).plusMonths(1).toDateTimeAtStartOfDay().toDate();
		buscar();
	}
	
	public String getMesStr(){
		DateFormat df = new SimpleDateFormat("MMMM 'de' yyyy", BR);
		return df.format(data);
	}
	
	public BigDecimal getTotalDespezas() {
		return totalDespezas;
	}
	
	public BigDecimal getTotalReceitas() {
		return totalReceitas;
	}
	
	public BigDecimal getSaldo(){
		return getTotalReceitas().add(getSaldoAnterior()) .subtract(getTotalDespezas());
	}

	public boolean isMostraConfirmarExclusao() {
		return mostraConfirmarExclusao;
	}

	public void setMostraConfirmarExclusao(boolean mostraConfirmarExclusao) {
		this.mostraConfirmarExclusao = mostraConfirmarExclusao;
	}

	public ItemFiltroCategoria getItemFiltroCategoria() {
		return itemFiltroCategoria;
	}

	public void setItemFiltroCategoria(ItemFiltroCategoria itemFiltro) {
		this.itemFiltroCategoria = itemFiltro;
	}
	
	public List<ItemFiltroCategoria> getCategorias() {
		return categorias;
	}
	
	public void setMes(int id){
		mes = new Mes(id);
	}
	
	public int getMes(){
		return mes.getId();
	}
	
	public int getAno() {

src/main/webapp/pages/movimentacoes/movimentacoes.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:pretty="http://ocpsoft.com/prettyfaces"
        xmlns:g="http://java.sun.com/jsf/composite/componentes"
        xmlns:p="http://primefaces.org/ui">

<ui:composition template="/templates/template.xhtml">

<ui:define name="titulo">Movimentações</ui:define>

<ui:define name="head">
<style>
html{
	position: relative;
	min-height: 100%;
}

body{
	margin: 0 0 100px;
}

footer{
	position: fixed;
	left: 0;
	right: 0;
	bottom: 0;
	height: 100px;
	width: 100%;
	background: #F0FFF0;
	border-top: 2px solid #e4eaee;
}
</style>
</ui:define>

<ui:define name="conteudo">

<h:panelGroup styleClass="row-fluid">
	<div class="span12" style="width: 97%">
		<h:form id="form">
			<div class="well well-samll row-fluid">
				<div class="span5">
					<h5 class="span5" style="margin-left: 5px;">Movimentações</h5>
				</div>
				<div class="span7" >
					<div class="input-append row-fluid">
						<div class="span12">
							<h:commandLink styleClass="btn"  style="border-radius: 4px 0 0 4px;height: 20px" action="#{movimentacoesController.voltaMes}">
								<i class="icon-arrow-left"></i>
							</h:commandLink>
							
							<h:commandButton type="button" value="#{movimentacoesController.mesStr}" 
								id="btnPeriodo" styleClass="btn" style="height: 30px" title="Escolher período" />
							
							<h:commandLink  styleClass="btn" style="height: 20px" action="#{movimentacoesController.avancaMes}">
								<i class="icon-arrow-right"></i>
							</h:commandLink>
							
							<p:overlayPanel for="btnPeriodo">
								<table>
									<tr>
										<td align="center" colspan="2">
											<h:commandLink value="Mês Corrente" styleClass="btn btn-link"  action="#{movimentacoesController.resetaBusca}" />
											<hr style="margin: 10px !important"/>
										</td>
									</tr>
									<tr>
										<td>
											<h:outputLabel value="Mês" />
											<h:selectOneMenu value="#{movimentacoesController.mes}" style="width: 70px">
												<f:selectItems value="#{colecoesController.meses}" var="m" itemLabel="#{m.nome}" itemValue="#{m.id}" />
											</h:selectOneMenu>
										</td>
										<td>
											<h:outputLabel value="Ano" />
											<h:selectOneMenu style="width: 70px" value="#{movimentacoesController.ano}">
												<f:selectItem itemLabel="2012" itemValue="2012" />
												<f:selectItem itemLabel="2013" itemValue="2013" />
												<f:selectItem itemLabel="2014" itemValue="2014" />
												<f:selectItem itemLabel="2015" itemValue="2015" />
												<f:selectItem itemLabel="2016" itemValue="2016" />
											</h:selectOneMenu>
										</td>
									</tr>
									<tr>
										<td align="center" colspan="2">
											<br/>
											<h:commandLink value="Filtrar" styleClass="btn" 
											 style="border-radius: 4x 4px 4px 4px" action="#{movimentacoesController.filtrar}">
												<i class="icon-filter" />
											</h:commandLink>
										</td>
									</tr>
								</table>
							</p:overlayPanel>
							
						</div>
					</div>
				</div>
			</div>
			<br/>
			
			<div class="row-fluid">
				<div class="span3">
					<g:multiCheckFilterList id="filtroCategorias" value="#{movimentacoesController.categorias}" itemLabel="nome" 
						itemSelect="#{movimentacoesController.itemFiltroCategoria}" 
						update=":form:movimentacoes"
						labelOpen="Abrir filtro por categoria"
						labelClose="Fechar filtro por categorias"
						clearSelectedItensListener="#{movimentacoesController.limparFiltroCategorias}"
						listener="#{movimentacoesController.addOuRemoveItemFiltroCategoria()}">
					</g:multiCheckFilterList>
				</div>
				<div class="span3">
					<g:multiCheckFilterList id="filtroModosPagamento" value="#{movimentacoesController.modosPagamento}" itemLabel="nome" 
						itemSelect="#{movimentacoesController.itemFiltroModoPagamento}" 
						update=":form:movimentacoes"
						labelOpen="Abrir filtro modo pagamento"
						clearSelectedItensListener="#{movimentacoesController.limparFiltroModoPagamento}"
						labelClose="Fechar filtro modo pagamento"
						listener="#{movimentacoesController.addOuRemoveItemFiltroModoPagamento()}">
					</g:multiCheckFilterList>
				</div>
				<div class="span6">
				</div>
			</div>
			
			<h:panelGroup id="movimentacoes">
				<table class="table table-striped table-bordered table-condensed" >
				<thead>
					<tr>
						<th>
							<h:outputText value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"  escape="false"/>
						</th>
						<th width="1%">
							<h:outputText value="data" />
						</th>
						<th>
							<h:outputText value="descirção" />
						</th>
						<th>
                            <h:outputText value="modo pagamento" />
						</th>
						<th>
                            <h:outputText value="categoria" />
						</th>
						<th>
							<h:outputText value="valor" />
						</th>
						<th width="1%">
							<h:outputText value="situação" />
						</th>
						<th>
							<h:outputText value="ação" />
						</th>
					</tr>
				</thead>
				<tbody>
				<ui:repeat value="#{movimentacoesController.lancamentos}" var="l"  varStatus="var">
					<tr>
						<td width="1%">
							<center>
								<h:panelGroup rendered="#{l.tipoLancamento eq 'ENTRADA'}">
									<img alt="Entrada :-)" title="Entrada :-)" width="25" height="25" src="#{request.contextPath}/resources/img/entrada.png" />
								</h:panelGroup>
								<h:panelGroup rendered="#{l.tipoLancamento eq 'SAIDA'}">
									<img width="25" height="25" alt="Saída :(" title="Saída :(" src="#{request.contextPath}/resources/img/saida.png" />
								</h:panelGroup>
							</center>
						</td>
						<td>
							<h:outputLabel styleClass="texto" value="#{l.dataLancamento}"  style="font-size: 11px !important">
								<f:convertDateTime pattern="dd/MM/yyyy" />
							</h:outputLabel>
						</td>
						<td>
							<h:outputLabel styleClass="texto" value="#{l.descricao}" style="font-size: 11px !important"/>
						</td>
						<td>
							<h:outputLabel styleClass="texto" value="#{l.tipoPagamento.nome}" style="font-size: 11px !important"/>
						</td>
						<td>
							<h:outputLabel styleClass="texto" value="#{l.todasCategorias}" style="font-size: 11px !important"/>
						</td>
						<td>
							<h:outputLabel styleClass="texto" value="#{l.valor}"  style="text-align: right; font-size: 11px !important">
								<f:convertNumber type="currency" currencySymbol="R$" maxFractionDigits="2" minFractionDigits="2" />
							</h:outputLabel>
						</td>
						<td width="1%">
							<center>
								<h:panelGroup rendered="#{l.pago}">
									<h:commandLink action="#{movimentacoesController.naoPago(l)}">
										<img alt="Clique para marcar como não pago" title="Clique para marcar como não pago" width="25" height="25" src="#{request.contextPath}/resources/img/pago.png" />
									</h:commandLink>
									
								</h:panelGroup>
								<h:panelGroup rendered="#{!l.pago}">
									<h:commandLink action="#{movimentacoesController.pago(l)}" >
										<img width="25" height="25" alt="Clique para marcar como pago" title="Clique para marcar como pago" src="#{request.contextPath}/resources/img/nao_pago.png" />
									</h:commandLink>
								</h:panelGroup>
							</center>
						</td>
						<td>
							<div id="meuCarrossel" class="carousel_#{var.index}">
								<div class="carousel-inner">
									<div class="active item">
										<h:commandLink title="Apagar lançamento" styleClass="btn btn-info" onclick="next('carousel_#{var.index}')"  >
											<i class="icon-trash"></i>
										</h:commandLink>
										<h:commandLink title="Editar lançamento" styleClass="btn btn-info offset1" action="#{movimentacoesController.editar(l)}">
											<i class="icon-edit"></i>
										</h:commandLink>
									</div>
									
									<div class="item" style="background: #EEE; border-radius: 0.35em">
										<div style="text-align: center">
											Confirma a exclusão deste lançamento ?
											<br/><br/>
											<div>
												<h:commandButton value="Sim" styleClass="btn btn-warning" onclick="previous('carousel_#{var.index}')" 
													action="#{movimentacoesController.remover(l)}" >
													<f:ajax render=":form:totais" />
												</h:commandButton>
												<h:commandButton value="Não" styleClass="btn btn-warning offset1" onclick="previous('carousel_#{var.index}')" />
											</div>
										</div>
									</div>
								</div>
							</div>
						</td>
					</tr>
				</ui:repeat>
				</tbody>
				<ui:fragment rendered="#{movimentacoesController.temTotalParcial}">
				<tfoot>
					<tr>
						<th colspan="5">
							Totais Pariciais
						</th>
						<th colspan="4">
							<h:outputText value="#{movimentacoesController.totalReceitaParcial}" styleClass="receita">
								<f:convertNumber type="currency" currencySymbol="R$" maxFractionDigits="2" minFractionDigits="2" />
							</h:outputText>
							<h:outputText value="#{movimentacoesController.totalDespezaParcial}" style="display: block!important;" styleClass="despezas">
								<f:convertNumber type="currency" currencySymbol="R$" maxFractionDigits="2" minFractionDigits="2" />
							</h:outputText>
						</th>
					</tr>
				</tfoot>
				</ui:fragment>
				</table>
			</h:panelGroup>
			
			<h:panelGroup id="totais">
				<footer>
					<div  style="text-align: justify;margin-left: 45%">
						<ul style="list-style: none">
							<li class="despezas">
								<h:outputText value="Total de despesas: " />
								<h:outputText value="#{movimentacoesController.totalDespezas}">
									<f:convertNumber type="currency" currencySymbol="R$" maxFractionDigits="2" minFractionDigits="2" />
								</h:outputText>
							</li>
							<li class="receita">
								<h:outputText value="Total receitas: " />
								<h:outputText value="#{movimentacoesController.totalReceitas}">
									<f:convertNumber type="currency" currencySymbol="R$" maxFractionDigits="2" minFractionDigits="2" />
								</h:outputText>
							</li>
<!-- 							<li> -->
<!-- 								<h:outputText value="Saldo do mês anterior:" /> -->
<!-- 								<h:outputText value="#{movimentacoesController.saldoAnterior}"> -->
<!-- 									<f:convertNumber type="currency" currencySymbol="R$" maxFractionDigits="2" minFractionDigits="2" /> -->
<!-- 								</h:outputText> -->
<!-- 							</li> -->
							<li class="#{movimentacoesController.saldo ge 0 ? 'saldo-positivo' : 'saldo-negativo'}">
								<h:outputText value="Saldo: " />
								<h:outputText value="#{movimentacoesController.saldo}">
									<f:convertNumber type="currency" currencySymbol="R$" maxFractionDigits="2" minFractionDigits="2" />
								</h:outputText>
							</li>
						</ul>
					</div>
				</footer>
			</h:panelGroup>
			
		</h:form>
	</div>
</h:panelGroup>
</ui:define>
</ui:composition>
</html>